
//	Jared King
//	Graphics 2004 

//---------------------------------------------------------------------------------------------------

#include <cstdlib>
#include <cmath>
#include <GL/glut.h>
#include <iostream>
#include "tga.h"
using namespace std;

static GLfloat theta = 0.0;
static GLint axis = 2;

GLUquadricObj *obj = gluNewQuadric();;

GLuint image[1];

GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
GLfloat ambient2[] = { 0.5, 0.5, 0.5, 1.0 };
GLfloat diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
GLfloat diffuse2[] = { 0.3, 0.3, 0.3, 1.0 };
GLfloat specular[] = { 1.0, 1.0, 1.0, 1.0 };
GLfloat light_position[] = {0, 7, 0, 1.0};
GLfloat light2_position[] = {0, 7, 0, 0.0};
GLfloat light_spot[] = {-1,-1,-1};
GLfloat position[] = { 0.0, 3.0, 2.0, 0.0 };
GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };
GLfloat local_view[] = { 0.0 };

GLfloat no_mat[] = { 0.0, 0.0, 0.0, 1.0 };
GLfloat mat_ambient[] = { 1, 1, 1, 1.0 };
GLfloat mat_ambient_color[] = { 0.8, 0.8, 0.2, 1.0 };
GLfloat mat_diffuse[] = { 0.1, 0.5, 0.8, 1.0 };
GLfloat mat_specular[] = { 1, 1, 1, 1.0 };
GLfloat no_shininess[] = { 0.0 };
GLfloat low_shininess[] = { 5.0 };
GLfloat high_shininess[] = { 200.0 };
GLfloat mat_emission[] = {0.3, 0.2, 0.2, 0.0};

float color[3] = {1.0, 1.0, 1.0};
float size[3] = {1.0, 1.0, 1.0};
float location[3] = {0.0, 0.0, 0.0};
float rotate[3] = {0.0, 0.0, 0.0};

//---------------------------------------------------------------------------------------------------

void drawCube(float cubeSize[3], float cubeColor[3], float cubeLocation[3], float cubeRotate[3])
{
	glPushMatrix();
	glTranslatef(cubeLocation[0], cubeLocation[1], cubeLocation[2]);
	glRotatef(cubeRotate[0], 1.0, 0.0, 0.0);
	glRotatef(cubeRotate[1], 0.0, 1.0, 0.0);
	glRotatef(cubeRotate[2], 0.0, 0.0, 1.0);
	glScalef(cubeSize[0], cubeSize[1], cubeSize[2]);
 	mat_diffuse[0] = cubeColor[0]; mat_diffuse[1] = cubeColor[1]; mat_diffuse[2] = cubeColor[2];
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glutSolidCube(0.5);
	glPopMatrix();
}

//---------------------------------------------------------------------------------------------------

void init(void) 
{
	glClearColor(0.0, 0.3, 0.7, 0.0); 
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);

	glLoadIdentity();

	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
	glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
	glEnable(GL_LIGHT0);

	glLightfv(GL_LIGHT1, GL_AMBIENT, ambient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT1, GL_POSITION, light2_position);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
	glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
	glEnable(GL_LIGHT1);


	glEnable(GL_TEXTURE_2D);

}

//---------------------------------------------------------------------------------------------------

void display(void)
{
	GLfloat light[3]={0.0, 7.0, 0.0};
	GLfloat m[16];

	//double sin(), cos();

	int i;
	for(i=0;i<16;i++) m[i]=0.0;

	light[0]=10.0*sin((6.28/180.0)*theta);
	light[2]=10.0*cos((6.28/180.0)*theta);
	m[0]=m[5]=m[10]=1.0;
	m[7]=-1.0/light[1];

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	/**********************************************************/

	glLoadIdentity();
	gluLookAt(-5,1,5,0,0.25,0,0,1,0);

	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
	glMaterialfv(GL_FRONT, GL_SPECULAR, no_mat);
	glMaterialfv(GL_FRONT, GL_SHININESS, no_shininess);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);

	/*************************Floor*******************************/

	CreateTexture(image,"data/floor.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glBegin(GL_QUADS);
	glTexCoord2f(-7.0, -7.0); glVertex3f(-10, -1, 7.5);
	glTexCoord2f(-7.0, 1.0); glVertex3f(-10, -1, -7.5);
	glTexCoord2f(1.0, 1.0); glVertex3f(7.5, -1, -7.5);
	glTexCoord2f(1.0, -7.0); glVertex3f(7.5, -1, 7.5);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);

	/***********************Right Wall*************************/
	
	CreateTexture(image,"data/wall2.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 

	size[0] = 0.01; size[1] = 10; size[2] = 35;
	color[0] = 0.8; color[1] = 0.8; color[2] = 0.8;
	location[0] = 7.5; location[1] = -1; location[2] = 0;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	/***********************Left Wall*************************/

	CreateTexture(image,"data/wall.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 

	size[0] = 1.5; size[1] = 10; size[2] = 0.25;
	color[0] = 0.9; color[1] = 0.9; color[2] = 0.9;
	location[0] = 6.65; location[1] = -1; location[2] = -7.5;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 7; size[1] = 3; size[2] = 0.25;
	color[0] = 0.8; color[1] = 0.8; color[2] = 0.8;
	location[0] = 5.1; location[1] = -0.545; location[2] = -7.5;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);
	glDisable(GL_TEXTURE_2D);


	/***********************Window*************************/

	CreateTexture(image,"data/window.tga",0);;

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST); 

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glBegin(GL_QUADS);
	glTexCoord2f(0, 0); glVertex3f(2, 0.25, -7.25);
	glTexCoord2f(0, 1.0); glVertex3f(2, 2, -7.25);
	glTexCoord2f(1.0, 1.0); glVertex3f(6, 2, -7.25);
	glTexCoord2f(1.0, 0); glVertex3f(6, 0.25, -7.25);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);

	glPushMatrix();
	glTranslatef(5.75, 1.5, -7.15);
	mat_diffuse[0] = 1; mat_diffuse[1] = 1; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glRotatef(90, 1, 0, 0);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.005, 0.005, 1, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(5.8, 1.5, -7.15);
	mat_diffuse[0] = 1; mat_diffuse[1] = 1; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glRotatef(90, 1, 0, 0);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.005, 0.005, 1, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(5.75, 0.5, -7.15);
	mat_diffuse[0] = 1; mat_diffuse[1] = 1; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glRotatef(90, 1, 0, 0);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.01, 0.03, 0.05, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(5.8, 0.5, -7.15);
	mat_diffuse[0] = 1; mat_diffuse[1] = 1; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glRotatef(90, 1, 0, 0);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.01, 0.03, 0.05, 25, 25);
	glPopMatrix();

	/************************Desk***************************/

	CreateTexture(image,"data/wood1.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	gluQuadricTexture(obj, GL_TRUE);
	gluQuadricDrawStyle(obj, GLU_FILL);
	size[0] = 1.5; size[1] = 1.25; size[2] = 1.25;
	color[0] = 0.8; color[1] = 0.6; color[2] = 0; 
	location[0] = 7.175; location[1] = -0.75; location[2] = -7.125;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.25; size[1] = 1.5; size[2] = 1.25;
	color[0] = 0.8; color[1] = 0.6; color[2] = 0;
	location[0] = 6.01; location[1] = -0.7379; location[2] = -7.125;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 3.25; size[1] = 0.15; size[2] = 1.25;
	color[0] = 0.8; color[1] = 0.6; color[2] = 0;
	location[0] = 6.75; location[1] = -0.4; location[2] = -7.125;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	/**********************Bookshelf************************/

	size[0] = 0.15; size[1] = 2; size[2] = 1;
	color[0] = 0.5; color[1] = 0.3; color[2] = 0; 
	location[0] = 4; location[1] = -0.75; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 2; size[2] = 1;
	color[0] = 0.5; color[1] = 0.3; color[2] = 0; 
	location[0] = 5.25; location[1] = -0.75; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 2.64; size[1] = 0.15; size[2] = 1;
	color[0] = 0.5; color[1] = 0.3; color[2] = 0; 
	location[0] = 4.625; location[1] = -0.287; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 2.64; size[1] = 0.15; size[2] = 1;
	color[0] = 0.5; color[1] = 0.3; color[2] = 0; 
	location[0] = 4.625; location[1] = -0.75; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	/**********************TV Stand************************/

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.6; color[1] = 0.6; color[2] = 0.2; 
	location[0] = 5.45; location[1] = -0.65; location[2] = -2.6;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.6; color[1] = 0.6; color[2] = 0.2; 
	location[0] = 5.45; location[1] = -0.65; location[2] = -1.8;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.4; color[1] = 0.4; color[2] = 0.2; 
	location[0] = 6.15; location[1] = -0.65; location[2] = -2.6;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.4; color[1] = 0.4; color[2] = 0.2; 
	location[0] = 6.15; location[1] = -0.65; location[2] = -1.8;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 1.6; size[1] = 0.15; size[2] = 1.9;
	color[0] = 0.6; color[1] = 0.6; color[2] = 0.2; 
	location[0] = 5.775; location[1] = -0.45; location[2] = -2.2;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	/**********************Table************************/

	glPushMatrix();
	glTranslatef(1, -0.5, 1.65);
	glRotatef(90, 1, 0, 0);
	mat_diffuse[0] = 0.8; mat_diffuse[1] = 0.6; mat_diffuse[2] = 0.2;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.05, 0.05, 0.5, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(0, -0.5, 1.65);
	glRotatef(90, 1, 0, 0);
	mat_diffuse[0] = 0.8; mat_diffuse[1] = 0.6; mat_diffuse[2] = 0.2;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.05, 0.05, 0.5, 25, 25);
	glPopMatrix();

	size[0] = 2.7; size[1] = 0.15; size[2] = 6;
	color[0] = 0.6; color[1] = 0.5; color[2] = 0.2; 
	location[0] = 0.5; location[1] = -0.5; location[2] = 0.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	glDisable(GL_TEXTURE_2D);

	glPushMatrix();
	glTranslatef(light[0], light[1],light[2]);
	glMultMatrixf(m);
	glTranslatef(-light[0], -light[1],-light[2]);
	glColor3f(0.0,0.0,0.0);
	glBegin(GL_POLYGON);
	 	glVertex3f(-0.85, -0.99, -2.75);
	 	glVertex3f(-0.85, -0.99, 3.25);
	 	glVertex3f(1.85, -0.99, 3.25);
	 	glVertex3f(1.85, -0.99, -2.75);
	glEnd();
	glPopMatrix();


	/*********************Computer***********************/

	//Tower
	size[0] = 0.5; size[1] = 0.8; size[2] = 0.75;
	color[0] = 0.1; color[1] = 0.1; color[2] = 0.1; 
	location[0] = 7.25; location[1] = -0.15; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	//Monitor Frame
	size[0] = 0.8; size[1] = 0.7; size[2] = 0.25;
	color[0] = 0.5; color[1] = 0.5; color[2] = 0.5; 
	location[0] = 6.75; location[1] = -0.15; location[2] = -7.25;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	//Rear half
	size[0] = 0.7; size[1] = 0.6; size[2] = 0.45;
	color[0] = 0.1; color[1] = 0.1; color[2] = 0.1; 
	location[0] = 6.75; location[1] = -0.175; location[2] = -7.4;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	//Base
	size[0] = 0.5; size[1] = 0.15; size[2] = 0.35;
	color[0] = 0.1; color[1] = 0.1; color[2] = 0.1; 
	location[0] = 6.75; location[1] = -0.38; location[2] = -7.4;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	//Screen
	CreateTexture(image,"data/screenshot.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_specular);

	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(6.575, -0.29, -7.175);
	glTexCoord2f(0.0, 1.0); glVertex3f(6.575, -0.01, -7.175);
	glTexCoord2f(1.0, 1.0); glVertex3f(6.9, -0.01, -7.175);
	glTexCoord2f(1.0, 0.0); glVertex3f(6.9, -0.29, -7.175);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);


	/**********************Lamp************************/
	glPushMatrix();
	glTranslatef(7, -0.935, -5.5);
	mat_diffuse[0] = 0.7; mat_diffuse[1] = 0.7; mat_diffuse[2] = 0.7;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	glRotatef(90, 1, 0, 0);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.2, 0.2, 0.05, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(7, 0.35, -5.5);
	glRotatef(90, 1, 0, 0);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.025, 0.025, 1.5, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(7, 0.35, -5.5);
	glRotatef(90, 1, 0, 0);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.10, 0.25, 0.4, 25, 25);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_SHININESS, no_shininess);

	/**********************Couch************************/

	size[0] = 3; size[1] = 1; size[2] = 7;
	color[0] = 0.8; color[1] = 0.2; color[2] = 0.2; 
	location[0] = -3; location[1] = -0.75; location[2] = 2;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.9; size[1] = 2; size[2] = 7;
	color[0] = 0.6; color[1] = 0.2; color[2] = 0.2; 
	location[0] = -3.65; location[1] = -0.1; location[2] = 2;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 15;
	drawCube(size,color,location,rotate);

	glPushMatrix();
	glTranslatef(-3.4, -0.35, 3.65);
	glRotatef(90, 0, 1, 0);
	mat_diffuse[0] = 0.3; mat_diffuse[1] = 0.1; mat_diffuse[2] = 0.1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.2, 0.2, 1.25, 25, 25);
	glPopMatrix();

	/**********************Chair************************/

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 4.75; location[1] = -0.65; location[2] = -5;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 1.4; size[2] = 0.15;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 4.75; location[1] = -0.475; location[2] = -4.6;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 0.7; size[2] = 0.15;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 5.15; location[1] = -0.65; location[2] = -5;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.15; size[1] = 1.4; size[2] = 0.15;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 5.15; location[1] = -0.475; location[2] = -4.6;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.9; size[1] = 0.15; size[2] = 0.9;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 4.95; location[1] = -0.5; location[2] = -4.8;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	size[0] = 0.9; size[1] = 0.35; size[2] = 0.15;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 4.95; location[1] = -0.21; location[2] = -4.6;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	/**********************TV************************/

	size[0] = 0.7; size[1] = 1.3; size[2] = 1.7;
	color[0] = 0.2; color[1] = 0.2; color[2] = 0.2; 
	location[0] = 5.6; location[1] = -0.1; location[2] = -2.2;
	rotate[0] = 0; rotate[1] = 0; rotate[2] = 0;
	drawCube(size,color,location,rotate);

	//TV Screen
	CreateTexture(image,"data/tv.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_specular);

	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(5.4, -0.35, -2.5);
	glTexCoord2f(0.0, 1.0); glVertex3f(5.4, 0.15, -2.5);
	glTexCoord2f(1.0, 1.0); glVertex3f(5.4, 0.15, -1.85);
	glTexCoord2f(1.0, 0.0); glVertex3f(5.4, -0.35, -1.85);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);

	//Poster
	CreateTexture(image,"data/poster.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_specular);

	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(7, 0, -5);
	glTexCoord2f(0.0, 1.0); glVertex3f(7, 1, -5);
	glTexCoord2f(1.0, 1.0); glVertex3f(7, 1, -4.1);
	glTexCoord2f(1.0, 0.0); glVertex3f(7, 0, -4.1);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);

	//Teapot
	glPushMatrix();
	glTranslatef(0.5, -0.35, 0.25);
	glRotatef(90, 0, 1, 0);
	mat_diffuse[0] = 0.5; mat_diffuse[1] = 0.5; mat_diffuse[2] = 0.5;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	glutSolidTeapot(0.2);
	glPopMatrix();
	glMaterialfv(GL_FRONT, GL_SHININESS, no_shininess);

	//Coke
	glPushMatrix();
	CreateTexture(image,"data/coke.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glTranslatef(0.5, -0.25, 1);
	mat_diffuse[0] = 1; mat_diffuse[1] = 1; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	glRotatef(90, 1, 0, 0);
	gluQuadricTexture(obj, GL_TRUE);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.07, 0.07, 0.225, 25, 25);
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_SHININESS, no_shininess);

	//Calendar
	CreateTexture(image,"data/calendar.tga",0);

	glEnable(GL_TEXTURE_2D);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_specular);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_specular);

	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(7.4, 0, -7);
	glTexCoord2f(-0.35, 0.97); glVertex3f(7.4, 0.4, -7);
	glTexCoord2f(0.65, 1.0); glVertex3f(7.4, 0.4, -6.5);
	glTexCoord2f(1.0, 0.0); glVertex3f(7.4, 0, -6.5);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);

	//TV Antenna
	glPushMatrix();
	glTranslatef(7, 0.55, -4.55);
	glRotatef(30, 1, 0, 0);
	mat_diffuse[0] = 0.8; mat_diffuse[1] = 0.8; mat_diffuse[2] = 0.8;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.01, 0.01, 1, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(7, 0.55, -2.75);
	glRotatef(150, 1, 0, 0);
	mat_diffuse[0] = 0.8; mat_diffuse[1] = 0.8; mat_diffuse[2] = 0.8;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.01, 0.01, 1, 25, 25);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(7, 0.1, -3.65);
	glRotatef(90, 1, 0, 0);
	mat_diffuse[0] = 0.8; mat_diffuse[1] = 0.8; mat_diffuse[2] = 0.8;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
	gluQuadricDrawStyle(obj, GLU_FILL);
	gluCylinder(obj, 0.05, 0.1, 0.05, 25, 25);
	glPopMatrix();

	glutPostRedisplay();
	glutSwapBuffers();
	glFlush();
}

//---------------------------------------------------------------------------------------------------

void mouse(int btn, int state, int x, int y)
{
// mouse callback
}

//---------------------------------------------------------------------------------------------------

void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    if (w <= h)
        glOrtho(-2.0, 2.0, -2.0 * (GLfloat) h / (GLfloat) w,
            2.0 * (GLfloat) h / (GLfloat) w, -20.0, 20.0);
    else
        glOrtho(-2.0 * (GLfloat) w / (GLfloat) h,
            2.0 * (GLfloat) w / (GLfloat) h, -2.0, 2.0, -20.0, 20.0);

    glMatrixMode(GL_MODELVIEW);
}

//---------------------------------------------------------------------------------------------------

int main(int argc, char **argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(800, 600);
    glutCreateWindow("My Scene");

    glutReshapeFunc(myReshape);
	init();
    glutDisplayFunc(display);
    glutIdleFunc(NULL);
    glutMouseFunc(mouse);
	glutKeyboardFunc(NULL);
    glEnable(GL_DEPTH_TEST);

    glutMainLoop();

	return 1;
}
//---------------------------------------------------------------------------------------------------
//End of scene.cpp